/*
 *  Smart Cache, http proxy cache server
 *  Copyright (C) 1998-2001 Radim Kolar
 *
 *    Smart Cache is Open Source Software; you may redistribute it
 *  and/or modify it under the terms of the GNU General Public
 *  License as published by the Free Software Foundation; either
 *  version 2, or (at your option) any later version.
 *
 *    This program distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  General Public License for more details.
 *
 *    A copy of the GNU General Public License is available as
 *  /usr/doc/copyright/GPL in the Debian GNU/Linux distribution or on
 *  the World Wide Web at http://www.gnu.org/copyleft/gpl.html. You
 *  can also obtain it by writing to the Free Software Foundation,
 *  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

import java.io.*;
import java.net.*;
import java.util.*;

public class uireq implements Runnable
{
    Socket s;
    DataInputStream in;
    DataOutputStream ou;
    boolean http10;
    
    uireq(Socket cs)
    {
	s=cs;
    }

    public void run()
    {
	http10=true;
	try 
	{ 
	    in=new DataInputStream (new BufferedInputStream(s.getInputStream()));
	    ou=new DataOutputStream(new BufferedOutputStream(s.getOutputStream()));

	/* precteme radku GET / */

	s.setSoTimeout(httpreq.client_timeout);

	String req=in.readLine();
	if(req==null) { s.close();ou.close();s=null;ou=null;return;}
	if (req.indexOf(" HTTP/",0)==-1) http10=false;
	String req2=null;

	/* access check */
	if(httpreq.allowed!=null) {
	   InetAddress adr;
	   adr=s.getInetAddress();
	   int j=httpreq.allowed.length;
	   boolean Block=true;

	   for(int i=0;i<j;i++) {
	      if (adr.equals(httpreq.allowed[i])) Block=false;
	   }
	   if (Block)
	      httpreq.server_error(http10,403,"Cache access denied.",ou);
	   }


	StringTokenizer st=new StringTokenizer(req);

	try
	{
	  req2=st.nextToken();
	  if(!req2.equals("GET")) 
	  {
	     httpreq.server_error(http10,501,"Method unimplemented in UI",ou);
	  }
	  req2=st.nextToken();
	  if(req2.charAt(0)!='/')
	  {
	    httpreq.server_error(http10,400,"Request URL not starting with /",ou);
	  }
	  send_reply(ui.process(req2));
        }
        catch (NoSuchElementException e) 
	{ 
	    httpreq.server_error(http10,400,"Incomplete request",ou);
	}
	
    }
    catch (IOException err)
    {
    }
}

public final void send_reply(String reply) throws IOException
{
    StringBuffer ans=new StringBuffer(2048);
    if(http10)
    {
	ans.append("HTTP/1.0 200 UI Reply Follows\r\n");
	ans.append("Server: ");
	ans.append(scache.CACHENAME);
	ans.append(" UI ");
	ans.append(ui.VERSION);
	ans.append("\r\nPragma: no-cache\r\nContent-Type: text/html\r\n\r\n");
    }
    if(reply==null) 
	ans.append("{-No reply- from UI }\n");
    else
	ans.append(reply);
    ou.writeBytes(ans.toString());
    ou.close();
    ou=null;
    s=null;
}

}
